//	^uRg[Tv(^ȗ}E폜E̕ύX)
//	Visual C++ 2013 32/64bit

#include <windows.h>
#include <commctrl.h> 
#include <stdio.h>
#include <tchar.h>
#include <vector>
#include "resource.h"

//	_CAO{bNXvV[W[
LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
//	^uRg[0y[W
LRESULT CALLBACK PageProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

//	nIndexŎ^u\Ԃɂ
void TabSelect(HWND hTab,int nIndex);

using namespace std;

vector<HWND> hPages;

HINSTANCE hInst;

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
                   TCHAR* lpszCmdLine, int nCmdShow){
	::hInst = hInstance;
	DialogBox(hInstance, TEXT("TAB_DLG"), 0, (DLGPROC)DlgProc1);
    return (int)0;
}


//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	static HWND hTab;
	static int max_num = 0;
	static HWND hEdit = 0;
	static int hEditPage = 0;
	static int nIndex = 0;
	TCHAR buf[32];
	DWORD n;
	RECT rc;
	TCITEM tc_item;
    switch (msg) {
        case WM_INITDIALOG:
			hTab = GetDlgItem(hDlg, IDC_TABCNTRL);
			tc_item.mask = TCIF_TEXT;
			for (n = 0; n < 3; n++){
				HWND h = CreateDialogParam(::hInst, _TEXT("DLG1"), hDlg, (DLGPROC)PageProc, (LPARAM)n);
				_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%d"), max_num++);
				tc_item.mask = TCIF_TEXT;
				tc_item.pszText = buf;
				TabCtrl_InsertItem(hTab, n, &tc_item);
				::hPages.push_back(h);
				ShowWindow(::hPages[n], SW_HIDE);
			}
			ShowWindow(::hPages[0], SW_SHOW);
			TabCtrl_SetCurSel(hTab, 0);
			GetClientRect(hDlg, &rc);
			SendMessage(hDlg, WM_SIZE, 0, MAKELPARAM(rc.right, rc.bottom));
			return TRUE;
		case WM_SIZE:{
			POINT dlg_pt;
			POINT tab_pt;
			dlg_pt.x = dlg_pt.y = 0;
			ClientToScreen(hDlg, &dlg_pt);
			tab_pt.x = tab_pt.y = 0;
			ClientToScreen(hTab, &tab_pt);

			GetClientRect(hTab, &rc);
			TabCtrl_AdjustRect(hTab, FALSE, &rc);

			int dx = tab_pt.x - dlg_pt.x;
			int dy = tab_pt.y - dlg_pt.y;
			for (n = 0; n < ::hPages.size(); n++)
				MoveWindow(::hPages[n], rc.left + dx, rc.top + dy, rc.right - rc.left, rc.bottom - rc.top, TRUE);
			break;
		}
		case WM_NOTIFY:
			switch (((NMHDR *)lParam)->code){
				case TCN_SELCHANGE:{	//	^u̐؂ւ
					if (hEdit){	//	^u̕ҏWLłB
						GetWindowText(hEdit, buf, sizeof(buf) / sizeof(TCHAR));
						tc_item.mask = TCIF_TEXT;
						tc_item.pszText = buf;
						TabCtrl_SetItem(hTab, hEditPage, &tc_item);
						DestroyWindow(hEdit);
						hEdit=0;
					}
					nIndex=TabCtrl_GetCurSel(hTab);
					TabSelect(hTab,nIndex);
					break;
				}
				case NM_RCLICK:{	//	^uŉENbN
					TCHITTESTINFO info;
					POINT p;
					GetCursorPos(&info.pt);
					p = info.pt;
					ScreenToClient(hTab, &info.pt);

					nIndex = TabCtrl_HitTest(hTab, &info);
					if (nIndex != -1){
						TabSelect(hTab,nIndex);
						HMENU hMenu = LoadMenu(::hInst, _TEXT("TAB_POPUP"));
						HMENU hSubmenu = GetSubMenu(hMenu, 0);
						TrackPopupMenu(hSubmenu, TPM_LEFTALIGN, p.x, p.y, 0, hDlg, NULL);
						DestroyMenu(hMenu);
					}
					break;
				}
			}
			return FALSE;
		case WM_COMMAND:
            switch (LOWORD(wParam)) {
				case IDM_INS:{
					ShowWindow(::hPages[nIndex], SW_HIDE);
					_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("%d"), max_num);
					tc_item.mask = TCIF_TEXT | TCIF_PARAM;
					tc_item.pszText = buf;
					tc_item.lParam = max_num;
					TabCtrl_InsertItem(hTab, nIndex, &tc_item);
					HWND h = CreateDialogParam(::hInst, _TEXT("DLG1"), hDlg, (DLGPROC)PageProc,(LPARAM)max_num);
					++max_num;
					vector<HWND>::iterator start;
					start = ::hPages.begin();
					::hPages.insert(start+nIndex,h);

					GetClientRect(hDlg, &rc);
					SendMessage(hDlg, WM_SIZE, 0, MAKELPARAM(rc.right, rc.bottom));

					TabSelect(hTab,nIndex);
					break;
				}
				case IDM_RENAME:{
					hEditPage = nIndex;
					RECT rect;
					tc_item.mask = TCIF_TEXT;
					tc_item.pszText = buf;
					tc_item.cchTextMax = sizeof(buf) / sizeof(TCHAR);
					TabCtrl_GetItem(hTab, nIndex, &tc_item);

					TabCtrl_GetItemRect(hTab, nIndex, &rect);	//	^ü̗擾
					POINT p1;
					p1.x = rect.left; p1.y = rect.top;
					int width=rect.right-rect.left;
					int height=rect.bottom-rect.top;
					hEdit = CreateWindow(
						TEXT("EDIT"), buf,
						WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT,
						p1.x, p1.y, width, height, hTab, (HMENU)1,
						hInst, NULL
						);
					SetFocus(hEdit);
					break;
				}
				case IDM_DEL:{
					if(1<::hPages.size()){	//	^u1͍̎폜Ȃ
						int i;
						if (nIndex){
							if (nIndex==::hPages.size()-1)	//	Ō̃^u폜Ƃ
								i = nIndex-1;
							else
								i = nIndex;
							TabCtrl_SetCurSel(hTab, 0);
						}else{
							i=0;
							TabCtrl_SetCurSel(hTab, 1);
						}
						TabCtrl_DeleteItem(hTab, nIndex);
						DestroyWindow(::hPages[nIndex]);
						vector<HWND>::iterator start;
						start = ::hPages.begin();
						:: hPages.erase(start + nIndex);
						TabSelect(hTab,i);
					}
					break;
				}
 				case IDM_RENUM:{	//	Iꂽ^uƉẼ^uƂ̏Ԃւ
					if (1 < ::hPages.size()){
						if (unsigned(nIndex) < ::hPages.size() - 1){
							TCHAR src[32], dtc[32];
							tc_item.mask = TCIF_TEXT;
							tc_item.pszText = src;
							tc_item.cchTextMax = sizeof(src) / sizeof(TCHAR);
							TabCtrl_GetItem(hTab, nIndex, &tc_item);
							tc_item.pszText = dtc;
							tc_item.cchTextMax = sizeof(dtc) / sizeof(TCHAR);
							TabCtrl_GetItem(hTab, nIndex + 1, &tc_item);
							tc_item.pszText = dtc;
							tc_item.cchTextMax = sizeof(dtc) / sizeof(TCHAR);
							TabCtrl_SetItem(hTab, nIndex, &tc_item);
							tc_item.pszText = src;
							tc_item.cchTextMax = sizeof(src) / sizeof(TCHAR);
							TabCtrl_SetItem(hTab, nIndex + 1, &tc_item);
							HWND temp = ::hPages[nIndex];
							::hPages[nIndex] = ::hPages[nIndex + 1];
							::hPages[nIndex + 1] = temp;
							TabSelect(hTab, nIndex);
							UpdateWindow(hTab);
						}
					}
					break;
				}
				case IDOK:{
					EndDialog(hDlg, TRUE);
					return TRUE;
				}
				case IDCANCEL:
					EndDialog(hDlg,FALSE);
					return FALSE;
				default:
					return FALSE;
			}
			default:
				return FALSE;
	}
	return TRUE;
}

//	^uRg[0y[W

LRESULT CALLBACK PageProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	int num;
	TCHAR* str[] = {
		_TEXT("00"),
		_TEXT("01`F"),
		_TEXT("02`"),
		_TEXT("03`"),
		_TEXT("04`"),
		_TEXT("05`"),
		_TEXT("06`"),
		_TEXT("07`"),
		_TEXT("08`"),
		_TEXT("09`"),
		_TEXT("10`"),
		_TEXT("11`"),
		_TEXT("12`P"),
		_TEXT("13`h"),
		_TEXT("14`"),
		0
	};
	switch (msg) {
	case WM_INITDIALOG:
		num = (int)lParam;
		SetWindowText(GetDlgItem(hDlg, IDC_EDIT1), str[num]);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_EDIT1:
			if (HIWORD(wParam) == EN_UPDATE){	//	GfBbg{bNXύXꂽꍇ
			}
			break;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

//	nIndexŎ^u\Ԃɂ

void TabSelect(HWND hTab,int nIndex){
	unsigned n;				
	for (n = 0; n < ::hPages.size(); n++)
		ShowWindow(::hPages[n], nIndex == n ? SW_SHOW : SW_HIDE);
	TabCtrl_SetCurSel(hTab, nIndex);
}
